accounts/urls.py
from django import views
from django.urls import path

from django.contrib.auth import views as auth_views

from django.contrib.auth import authenticate, login

# from django.views import SignUpView
from accounts.views import signup


urlpatterns = [
    # path("", ReceiptListView.as_view(), name="home"),
    # path("admin/", admin.site.urls),
    #    path("login/", Login, name="login"),
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

expenses/urls.py
from django import views
from django.contrib import admin
from django.urls import path
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views


urlpatterns = [
    path("admin/", admin.site.urls),
    path("receipts/", include("receipts.urls")),
    path("receipts/accounts/", include("accounts.urls")),
    path("receipts/accounts/", include("django.contrib.auth.urls")),
    path("accounts/", include("accounts.urls")),
    path("accounts/", include("django.contrib.auth.urls")),
    # path("accounts/", auth_views.LoginView.as_view(), name="login"),
    # path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("home")),
    ),
]

receipts/urls.py
from django.urls import path

from receipts.views import (
    AccountCreateView,
    AccountListView,
    CategoryCreateView,
    CategoryListView,
    ReceiptListView,
    ReceiptCreateView,
)

urlpatterns = [
    path("", ReceiptListView.as_view(), name="home"),
    path("create/", ReceiptCreateView.as_view(), name="receipt_new"),
    path("accounts/", AccountListView.as_view(), name="account_list"),
    path("categories/", CategoryListView.as_view(), name="category_list"),
    path("accounts/create/", AccountCreateView.as_view(), name="account_new"),
    path(
        "categories/create/", CategoryCreateView.as_view(), name="category_new"
    ),
]

accounts/models.py
from django.db import models

# Create your models here.

receipts/models.py
from django.db import models

# from django.db.models import Sum, Count

# Create your models here.
# from django.core.validators import MaxValueValidator, MinValueValidator
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL


# Create your models here.
class Receipt(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(max_digits=10, decimal_places=3)
    tax = models.DecimalField(max_digits=10, decimal_places=3)
    date = models.DateField()

    # description = models.TextField()
    category = models.ForeignKey(
        "ExpenseCategory",
        related_name="receipts",
        on_delete=models.CASCADE,
    )
    purchaser = models.ForeignKey(
        USER_MODEL,
        related_name="receipts",
        on_delete=models.CASCADE,
    )
    account = models.ForeignKey(
        "Account",
        related_name="receipts",
        on_delete=models.CASCADE,
    )

    def __str__(self):
        return str(self.vendor)


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50)
    ownerr = models.ForeignKey(
        USER_MODEL,
        related_name="categories",
        on_delete=models.CASCADE,
    )
    # sum = Receipt.objects.count()

    # print(sum)
    #    print(pubs)

    def __str__(self):
        return str(self.name)


class Account(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=20)
    # sum = Receipt.objects.count()
    ownerr = models.ForeignKey(
        USER_MODEL,
        related_name="accounts",
        on_delete=models.CASCADE,
    )
    # print(sum)

    def __str__(self):
        return str(self.name)

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.contrib.auth import login, authenticate
from django.contrib import messages


# Create your views here.
def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():

            username = request.POST["username"]
            password = request.POST["password1"]
            user = User.objects.create_user(username, password)
            user.save()
            login(request, user)
            return redirect("home")

    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/signup.html", context)

receipts/views.py
from django.db import IntegrityError
from django.shortcuts import redirect
from django.urls import reverse_lazy
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.decorators.http import require_http_methods
from django.db.models import Sum, Count


# from recipes.forms import RecipeForm
from receipts.models import Account, ExpenseCategory, Receipt


class ReceiptListView(LoginRequiredMixin, ListView):
    model = Receipt
    template_name = "receipts/list.html"

    def get_queryset(self):
        return Receipt.objects.filter(purchaser=self.request.user)


class ReceiptCreateView(LoginRequiredMixin, CreateView):  # LoginRequiredMixin
    model = Receipt
    template_name = "receipts/newrec.html"
    fields = [
        "vendor",
        "total",
        "tax",
        "date",
        "category",
        "account",
    ]

    success_url = reverse_lazy("home")

    # def form_valid(self, form):
    #     form.instance.author = self.request.user
    #     return super().form_valid(form)

    def form_valid(self, form):
        item = form.save(commit=False)
        item.purchaser = self.request.user
        item.save()
        return redirect("home")


class CategoryCreateView(LoginRequiredMixin, CreateView):  # LoginRequiredMixin
    model = ExpenseCategory
    template_name = "receipts/newcat.html"
    fields = ["name"]
    success_url = reverse_lazy("home")

    # def form_valid(self, form):
    #     form.instance.author = self.request.user
    #     return super().form_valid(form)
    def form_valid(self, form):
        item = form.save(commit=False)
        item.ownerr = self.request.user
        item.save()
        return redirect("category_list")


class AccountCreateView(LoginRequiredMixin, CreateView):
    model = Account
    template_name = "receipts/newaccount.html"
    fields = ["name", "number"]
    success_url = reverse_lazy("home")

    # def form_valid(self, form):
    #     form.instance.author = self.request.user
    #     return super().form_valid(form)

    def form_valid(self, form):
        item = form.save(commit=False)
        item.ownerr = self.request.user
        item.save()
        return redirect("account_list")


class CategoryListView(LoginRequiredMixin, ListView):
    model = ExpenseCategory
    template_name = "receipts/listcat.html"

    def get_queryset(self):
        return ExpenseCategory.objects.filter(ownerr=self.request.user)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["total"] = ExpenseCategory.objects.annotate(
            num=Count("receipts")
        )
        return context


class AccountListView(LoginRequiredMixin, ListView):
    model = Account
    template_name = "receipts/listaccount.html"

    def get_queryset(self):
        return Account.objects.filter(ownerr=self.request.user)

receipts/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>New Recipe - Scrumptious</title>
  <link rel="stylesheet" href="{% static 'css/app.css' %}">
</head>

<body>
  <header>
    <nav>
      <ul>
        {% if user.is_authenticated %}
        <li>
          <a href="{% url 'receipt_new' %}">New Receipt</a>
        </li>
        <li>
          <a href="{% url 'category_list' %}">Categories</a>
        </li>
        <li>
          <a href="{% url 'category_new' %}">New Categories</a>
        </li>
        <li>
            <a href="{% url 'account_list' %}">Accounts</a>
          </li>
          <li>
            <a href="{% url 'account_new' %}">New Accounts</a>
          </li>
          <li>
            <a href="{% url 'home' %}">home</a>
          </li>
        {% endif %} 

      </ul>
    </nav> 
  </header>
  {% block content %}
  {% endblock content %}
  {% if user.is_authenticated %}
  <li>
    <a href="{% url 'logout' %}">Logout</a>
  </li>
  {% else %}
  <li>
    <a href="{% url 'login' %}">Login</a>
  </li>
  <li>
    <a href="{% url 'signup' %}">Sign Up</a>
  </li>
  {% endif %} 

</body>

</html>

receipts/templates/receipts/list.html
{% extends 'base.html' %}


    {% block content %}

  </header>
  <h1> Receipts </h1>
  <main class="recipe-grid">
    {% for receipt in receipt_list %}
      <div class="recipe-card">
        <h2 class="recipe-card-title">
            {{receipt.vendor}}
            {{receipt.total}}
            {{receipt.tax}}

            {{receipt.date}}
            {{receipt.category}}
            {{receipt.account}} 

          {% comment %} <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a> {% endcomment %}
        </h2>
        {% comment %} <p class="recipe-card-date">{{ recipe.updated }}</p> {% endcomment %}
      </div>
    {% endfor %}
  </main>
  {% endblock content %}

receipts/templates/receipts/listaccount.html
{% extends 'base.html' %}


{% block content %}

</header>
<h1> Accounts </h1>
<main class="recipe-grid">
{% for account in account_list %}
  <div class="recipe-card">
    <h2 class="recipe-card-title">
        {{account.name}}
  
        {{account.number}}

      {{ account.receipts.all|length}}


      {% comment %} <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a> {% endcomment %}
    </h2>
    {% comment %} <p class="recipe-card-date">{{ recipe.updated }}</p> {% endcomment %}
  </div>
{% endfor %}
</main>
{% endblock content %}


{% comment %} <div class="container">
    <div class="row">
      <div class="col-sm-6">
        {{ usercontent.thing_a }}
      </div>
      <div class="col-sm-6">
        {{ usercontent.thing_b }}
      </div>
    </div>
  </div> {% endcomment %}

receipts/templates/receipts/listcat.html
{% extends 'base.html' %}


{% block content %}

</header>
<h1> Expense Categories </h1>
<main class="recipe-grid">

{% for cat in expensecategory_list %}
  <div class="recipe-card">
    <h2 class="recipe-card-title">
        {{cat.name}}
        {{ cat.receipts.all|length }}
        

        
      {% comment %} <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a> {% endcomment %}
    </h2>
    {% comment %} <p class="recipe-card-date">{{ recipe.updated }}</p> {% endcomment %}
  </div>
{% endfor %}
</main>
{% endblock content %}

receipts/templates/receipts/newaccount.html
{% extends 'base.html' %}
{% block content %}

   <main class="todos-form">
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Create</button>
      </div>
    </form>
  </main> 
  {% endblock content %}

receipts/templates/receipts/newcat.html
{% extends 'base.html' %}
{% block content %}

   <main class="todos-form">
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Create</button>
      </div>
    </form>
  </main> 
  {% endblock content %}

receipts/templates/receipts/newrec.html
{% extends 'base.html' %}
{% block content %}

   <main class="todos-form">
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Create</button>
      </div>
    </form>
  </main> 
  {% endblock content %}